local GarrisonOrderHallReportButtons = {}
local GarrisonOrderHallReportGarrisons = {}
GarrisonOrderHallReportGarrison = nil

function GarrisonOrderHallReportFixFrame()
	if GarrisonLandingPage.garrTypeID == 111 then
		GarrisonLandingPage.CovenantCallings:Show()
		GarrisonLandingPage.SoulbindPanel:Show()
		if C_ArdenwealdGardening.IsGardenAccessible() then
			GarrisonLandingPage.ArdenwealdGardeningPanel:Show()
		end
	else
		GarrisonLandingPage.CovenantCallings:Hide()
		GarrisonLandingPage.SoulbindPanel:Hide()
		if C_ArdenwealdGardening.IsGardenAccessible() then
			GarrisonLandingPage.ArdenwealdGardeningPanel:Hide()
		end
		GarrisonLandingPage.FollowerTabButton:SetText("Followers")
	end
end

GarrisonLandingPageMinimapButton:SetScript("OnClick", function(self, button, down)
	GarrisonLandingPage_Toggle()
	HideUIPanel(GarrisonLandingPage)
	if button == GarrisonOrderHallReportButton then
		HideUIPanel(GarrisonLandingPage)
		ToggleDropDownMenu(1, nil, GarrisonReportDropDown, self, 0, 0)
	elseif button == "LeftButton" then
		if GarrisonOrderHallReportGarrison == nil then
			GarrisonLandingPage_Toggle()
			GarrisonOrderHallReportFixFrame()
		else
			if GarrisonLandingPage:IsShown() then
				HideUIPanel(GarrisonLandingPage)
			else
				ShowGarrisonLandingPage(GarrisonOrderHallReportGarrison)
				GarrisonOrderHallReportFixFrame()
			end
		end
	end
	GarrisonLandingPage.FollowerTab:SetScript("OnShow", function(self)
		if GarrisonLandingPage.garrTypeID ~= 111 then
			GarrisonLandingPage.FollowerList:Show()
			GarrisonLandingPage.FollowerList.LandingPageHeader:SetText("Followers")
			self.CovenantFollowerPortraitFrame:Hide()
			local followerInfo = C_Garrison.GetFollowerInfo(self.followerID)
			followerInfo.autoSpellAbilities = C_Garrison.GetFollowerAutoCombatSpells(self.followerID, followerInfo.level or 1)
			followerInfo.autoCombatantStats = C_Garrison.GetFollowerAutoCombatStats(self.followerID)
			self:UpdateAutoSpellAbilities(followerInfo)
			self.AbilitiesFrame.Abilities[1]:Hide()
			self.AbilitiesFrame.Abilities[2]:Hide()
			self:ShowFollower(self.followerID)
		end
	end)
end)

function GarrisonOrderHallReportFrameOnEvent(self, event, arg1)
	if event == "ADDON_LOADED" and arg1 == "GarrisonOrderHallReport" then
		if GarrisonOrderHallReportButton == nil then
			GarrisonOrderHallReportButton = "RightButton"
		end
		self:UnregisterEvent("ADDON_LOADED")
	end
	if UnitLevel("player") >= 10 then
		GarrisonLandingPageMinimapButton:Show()
	end
end

function GarrisonReportDropDownOnLoad()
	local garrison = {}
	garrison.text = "Garrison"
	garrison.value = 2
	garrison.func = GarrisonReportDropDownOnClick
	local order = {}
	order.text = "Order Hall"
	order.value = 3
	order.func = GarrisonReportDropDownOnClick
	local missions = {}
	missions.text = "Missions"
	missions.value = 9
	missions.func = GarrisonReportDropDownOnClick
	local covenant = {}
	covenant.text = "Covenant Sanctum"
	covenant.value = 111
	covenant.func = GarrisonReportDropDownOnClick
	UIDropDownMenu_AddButton(garrison)
	UIDropDownMenu_AddButton(order)
	UIDropDownMenu_AddButton(missions)
	UIDropDownMenu_AddButton(covenant)
end

function GarrisonReportDropDownOnClick(value)
	ShowGarrisonLandingPage(value.value)
	GarrisonOrderHallReportFixFrame()
end

function GarrisonOrderHallReportRadioButtonClick(self)
	for i = 1, table.getn(GarrisonOrderHallReportButtons) do
		GarrisonOrderHallReportButtons[i]:SetChecked(false)
	end
	self:SetChecked(true)
end

function GarrisonOrderHallReportRadioGarrisonClick(self)
	for i = 1, table.getn(GarrisonOrderHallReportGarrisons) do
		GarrisonOrderHallReportGarrisons[i]:SetChecked(false)
	end
	self:SetChecked(true)
end

function GarrisonOrderHallReportRadioButton(text, parent, x, y)
	local button = CreateFrame("CheckButton", nil, parent, "UIRadioButtonTemplate")
	local font = button:CreateFontString(nil, nil, "GameFontNormal")
	font:SetText(text)
	font:SetPoint("LEFT", x, 0)
	button:SetFontString(font)
	button:SetPoint("TOPLEFT", x, y)
	button:Show()
	button:SetScript("OnClick", GarrisonOrderHallReportRadioButtonClick)
	table.insert(GarrisonOrderHallReportButtons, button)
end

function GarrisonOrderHallReportRadioGarrison(text, parent, x, y)
	local button = CreateFrame("CheckButton", nil, parent, "UIRadioButtonTemplate")
	local font = button:CreateFontString(nil, nil, "GameFontNormal")
	font:SetText(text)
	font:SetPoint("LEFT", x, 0)
	button:SetFontString(font)
	button:SetPoint("TOPLEFT", x, y)
	button:Show()
	button:SetScript("OnClick", GarrisonOrderHallReportRadioGarrisonClick)
	table.insert(GarrisonOrderHallReportGarrisons, button)
end

function GarrisonOrderHallReportOptionsRefresh()
	if GarrisonOrderHallReportButton == "RightButton" then
		GarrisonOrderHallReportButtons[1]:SetChecked(true)
		GarrisonOrderHallReportButtons[2]:SetChecked(false)
	else
		GarrisonOrderHallReportButtons[1]:SetChecked(false)
		GarrisonOrderHallReportButtons[2]:SetChecked(true)
	end
	if GarrisonOrderHallReportGarrison == 2 then
		GarrisonOrderHallReportGarrisons[1]:SetChecked(true)
		GarrisonOrderHallReportGarrisons[2]:SetChecked(false)
		GarrisonOrderHallReportGarrisons[3]:SetChecked(false)
		GarrisonOrderHallReportGarrisons[4]:SetChecked(false)
	elseif GarrisonOrderHallReportGarrison == 3 then
		GarrisonOrderHallReportGarrisons[1]:SetChecked(false)
		GarrisonOrderHallReportGarrisons[2]:SetChecked(true)
		GarrisonOrderHallReportGarrisons[3]:SetChecked(false)
		GarrisonOrderHallReportGarrisons[4]:SetChecked(false)
	elseif GarrisonOrderHallReportGarrison == 9 then
		GarrisonOrderHallReportGarrisons[1]:SetChecked(false)
		GarrisonOrderHallReportGarrisons[2]:SetChecked(false)
		GarrisonOrderHallReportGarrisons[3]:SetChecked(true)
		GarrisonOrderHallReportGarrisons[4]:SetChecked(false)
	elseif GarrisonOrderHallReportGarrison == 111 then
		GarrisonOrderHallReportGarrisons[1]:SetChecked(false)
		GarrisonOrderHallReportGarrisons[2]:SetChecked(false)
		GarrisonOrderHallReportGarrisons[3]:SetChecked(false)
		GarrisonOrderHallReportGarrisons[4]:SetChecked(true)
	end
end

function GarrisonOrderHallReportOptionsOkay()
	if GarrisonOrderHallReportButtons[1]:GetChecked() then
		GarrisonOrderHallReportButton = "RightButton"
	else
		GarrisonOrderHallReportButton = "MiddleButton"
	end
	if GarrisonOrderHallReportGarrisons[1]:GetChecked() then
		GarrisonOrderHallReportGarrison = 2
	elseif GarrisonOrderHallReportGarrisons[2]:GetChecked() then
		GarrisonOrderHallReportGarrison = 3
	elseif GarrisonOrderHallReportGarrisons[3]:GetChecked() then
		GarrisonOrderHallReportGarrison = 9
	elseif GarrisonOrderHallReportGarrisons[4]:GetChecked() then
		GarrisonOrderHallReportGarrison = 111
	end
end

local GarrisonOrderHallReportFrame = CreateFrame("FRAME", nil, UIParent)
GarrisonOrderHallReportFrame:RegisterEvent("ADDON_LOADED")
GarrisonOrderHallReportFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
GarrisonOrderHallReportFrame:RegisterEvent("PLAYER_UPDATE_RESTING")
GarrisonOrderHallReportFrame:RegisterEvent("ZONE_CHANGED")
GarrisonOrderHallReportFrame:RegisterEvent("ZONE_CHANGED_INDOORS")
GarrisonOrderHallReportFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
GarrisonOrderHallReportFrame:RegisterEvent("PLAYER_LOGIN")
GarrisonOrderHallReportFrame:SetScript("OnEvent", GarrisonOrderHallReportFrameOnEvent)
GarrisonLandingPageMinimapButton:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp")
GarrisonReportDropDown = CreateFrame("FRAME", "GarrisonReportDropDown", UIParent, "UIDropDownMenuTemplate")
UIDropDownMenu_Initialize(GarrisonReportDropDown, GarrisonReportDropDownOnLoad, "MENU")

local GarrisonOrderHallReportOptions = CreateFrame("FRAME")
GarrisonOrderHallReportOptions.name = "Garrison Order Hall Report"
GarrisonOrderHallReportRadioButton("Right Mouse Button", GarrisonOrderHallReportOptions, 20, -20)
GarrisonOrderHallReportRadioButton("Middle Mouse Button", GarrisonOrderHallReportOptions, 20, -40)
GarrisonOrderHallReportRadioGarrison("Garrison", GarrisonOrderHallReportOptions, 20, -100)
GarrisonOrderHallReportRadioGarrison("Order Hall", GarrisonOrderHallReportOptions, 20, -120)
GarrisonOrderHallReportRadioGarrison("Missions", GarrisonOrderHallReportOptions, 20, -140)
GarrisonOrderHallReportRadioGarrison("Covenant Sanctum", GarrisonOrderHallReportOptions, 20, -160)
GarrisonOrderHallReportOptions.refresh = GarrisonOrderHallReportOptionsRefresh
GarrisonOrderHallReportOptions.okay = GarrisonOrderHallReportOptionsOkay
GarrisonOrderHallReportOptions.cancel = GarrisonOrderHallReportOptionsRefresh
InterfaceOptions_AddCategory(GarrisonOrderHallReportOptions)